"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const useForm = (initial, callback, validate) => {
    const [values, setValues] = react_1.useState(initial);
    const [errors, setErrors] = react_1.useState({});
    const [isSubmitting, setIsSubmitting] = react_1.useState(false);
    react_1.useEffect(() => {
        if (Object.keys(errors).length === 0 && isSubmitting) {
            callback();
        }
    }, [errors]);
    const handleSubmit = () => {
        setErrors(validate(values));
        setIsSubmitting(true);
    };
    const handleChange = (text, name) => {
        setValues((values) => (Object.assign(Object.assign({}, values), { [name]: text })));
    };
    return {
        handleChange,
        handleSubmit,
        values,
        errors,
    };
};
exports.default = useForm;
